import { Controller, Get, Inject } from '@midwayjs/decorator';
import { Context } from '@midwayjs/koa';
import { ApiResponse, ApiTags } from '@midwayjs/swagger';
import { ToolService } from '../service/tool.service';
const assert = require('assert');
import { JwtService } from '@midwayjs/jwt';
import get = require('lodash/get');
@ApiTags(['工具'])
@Controller('/tool')
export class ToolController {
  @Inject()
  service: ToolService;

  @Inject()
  jwtService: JwtService;

  @Inject()
  ctx: Context;

  @Get('/token')
  @ApiResponse({})
  async tokenView() {
    const token = get(this.ctx, 'request.header.token');
    assert(token, '缺少token信息');
    const result: any = await this.jwtService.decode(token);
    return result;
  }

  @Get('/app')
  async appLogin(fiiter) {
    const { config, js_code } = fiiter.query;
    const result: any = await this.service.appLogin(config, js_code);
    return result;
  }
}
