import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'activity' },
})
export class Activity extends BaseModel {
  @prop({ required: false, index: true, zh: '活动名称' })
  name: string;
  @prop({
    required: false,
    index: true,
    zh: '类型',
    remark: '字典表:activity_type',
  })
  type: string;
  @prop({ required: false, index: false, zh: '图片' })
  file: Array<any>;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: false, zh: '创建时间' })
  create_time: string;
  @prop({ required: false, index: true, zh: '排序' })
  sort: number;
  @prop({
    required: false,
    index: true,
    zh: '是否启用',
    remark: '字典表:is_use',
    default: '0',
  })
  is_use: string;
}
