import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import isString = require('lodash/isString');
@modelOptions({
  schemaOptions: { collection: 'admin' },
})
export class Admin extends BaseModel {
  @prop({ required: true, index: true, zh: '账号' })
  account: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: {
    secret: string;
  };
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: true, zh: '角色' })
  role: string;
  @prop({ required: false, index: true, zh: '类型' })
  type: string;
  @prop({ required: false, index: true, zh: '所属区域' })
  region: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表:exam_status',
    default: '0',
  })
  status: string;
}
