import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'afterSale' },
})
export class AfterSale extends BaseModel {
  @prop({ required: false, index: true, zh: '订单', ref: 'order' })
  order: string;
  @prop({ required: false, index: true, zh: '用户', ref: 'user' })
  user: string;
  @prop({
    required: false,
    index: true,
    zh: '类型',
    remark: '字典表:order_type',
  })
  type: string;
  @prop({ required: false, index: false, zh: '申请理由' })
  reason: string;
  @prop({ required: false, index: false, zh: '凭证图片' })
  file: Array<any>;
  @prop({ required: false, index: true, zh: '申请时间' })
  apply_time: string;
}
