import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'article' },
})
export class Article extends BaseModel {
  @prop({ required: true, index: true, zh: '发布人' })
  contact: string;
  @prop({ required: true, index: true, zh: '发布姓名' })
  contact_name: string;
  @prop({ required: false, index: true, zh: '标题' })
  title: string;
  @prop({ required: false, index: false, zh: '图片' })
  file: Array<any>;
  @prop({ required: false, index: false, zh: '内容' })
  content: string;
  @prop({
    required: false,
    index: true,
    zh: '类型',
    remark: '字典表:home_tabs',
  })
  type: string;
  @prop({ required: false, index: false, zh: '创建时间' })
  create_time: string;
  @prop({ required: false, index: true, zh: '排序' })
  sort: number;
  @prop({ required: false, index: true, zh: '点赞数' })
  like_num: number;
  @prop({
    required: false,
    index: true,
    zh: '是否启用',
    remark: '字典表:is_use',
    default: '0',
  })
  is_use: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表:exam_status',
  })
  status: string;
}
