import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'comment' },
})
export class Comment extends BaseModel {
  @prop({ required: true, index: true, zh: '用户' })
  user: string;
  @prop({ required: true, index: true, zh: '用户名称' })
  user_name: string;
  @prop({ required: true, index: true, zh: '来源', ref: 'article' })
  source: string;
  @prop({ required: false, index: false, zh: '内容' })
  content: string;
  @prop({ required: false, index: true, zh: '创建时间' })
  create_time: string;
  @prop({
    required: false,
    index: true,
    zh: '是否启用',
    remark: '字典表:is_use',
    default: '0',
  })
  is_use: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表:exam_status',
    default: '0',
  })
  status: string;
}
