import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'config' },
})
export class Config extends BaseModel {
  @prop({ required: false, index: true, zh: '景区名称' })
  name: string;
  @prop({ required: false, index: false, zh: '电话号' })
  phone: string;
  @prop({ required: false, index: false, zh: '地址' })
  address: string;
  @prop({ required: false, index: false, zh: '图片' })
  file: Array<any>;
  @prop({ required: false, index: false, zh: '首页图片' })
  logo_url: Array<any>;
  @prop({ required: false, index: false, zh: '视频' })
  video: Array<any>;
  @prop({ required: false, index: false, zh: '开放时间' })
  open_time: string;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: false, zh: '优待政策' })
  policy: string;
  @prop({ required: false, index: false, zh: '用户协议' })
  agreement: string;
  @prop({ required: false, index: false, zh: '隐私政策' })
  secret: string;
  @prop({ required: false, index: true, zh: '景区地理经度' })
  longitude: number;
  @prop({ required: false, index: true, zh: '景区地理纬度' })
  latitude: number;
  @prop({ required: false, index: true, zh: '景区地图缩放比例', default: 13 })
  scale: number;
  @prop({ required: false, index: false, zh: '底部文案' })
  bottom_title: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表:config_status',
    default: '0',
  })
  status: string;
}
