import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'coupon' },
})
export class Coupon extends BaseModel {
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({ required: false, index: false, zh: '数量' })
  num: number;
  @prop({ required: false, index: false, zh: '类型' })
  type: string;
  @prop({ required: false, index: false, zh: '失效方式' })
  expire_type: string;
  @prop({ required: false, index: false, zh: '失效配置' })
  expire_config: object;
  @prop({ required: false, index: false, zh: '减免方式' })
  discount_type: string;
  @prop({ required: false, index: false, zh: '减免配置' })
  discount_config: object;
  @prop({ required: false, index: false, zh: '使用限制' })
  use_limit: string;
  @prop({ required: false, index: false, zh: '使用配置' })
  use_limit_config: object;
  @prop({ required: false, index: false, zh: '领取限制' })
  get_limit: string;
  @prop({ required: false, index: false, zh: '领取配置' })
  get_limit_config: object;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: true, zh: '排序' })
  sort: number;
  @prop({
    required: false,
    index: true,
    zh: '是否启用',
    remark: '字典表:is_use',
    default: '0',
  })
  is_use: string;
}
