import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'dictData' },
})
export class DictData extends BaseModel {
  @prop({ required: false, index: true, zh: '类型' })
  type: string;
  @prop({ required: false, index: true, zh: '标签' })
  label: string;
  @prop({ required: false, index: true, zh: '键值' })
  value: string;
  @prop({ required: false, index: true, zh: '排序' })
  sort: number;
  @prop({ required: false, index: false, zh: '字数据' })
  children: Array<any>;
  @prop({
    required: false,
    index: true,
    zh: '是否启用',
    remark: '字典表:is_use',
    default: '0',
  })
  is_use: string;
}
