import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'hotel' },
})
export class Hotel extends BaseModel {
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({ required: false, index: true, zh: '地址' })
  address: string;
  @prop({ required: false, index: true, zh: '客房数' })
  num: number;
  @prop({ required: false, index: false, zh: '图片' })
  file: Array<any>;
  @prop({ required: false, index: true, zh: '联系电话' })
  phone: string;
  @prop({ required: false, index: true, zh: '入住时间' })
  start_time: string;
  @prop({ required: false, index: true, zh: '退房时间' })
  end_time: string;
  @prop({ required: false, index: false, zh: '儿童及加床' })
  children: string;
  @prop({ required: false, index: false, zh: '接待提示' })
  prompt: string;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: true, zh: '排序' })
  sort: number;
  @prop({
    required: false,
    index: false,
    zh: '是否使用',
    remark: '字典表:is_use',
  })
  is_use: string;
  @prop({
    required: false,
    index: false,
    zh: '状态',
    remark: '字典表：exam_status',
    default: '0',
  })
  status: string;
}
