import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'like' },
})
export class Like extends BaseModel {
  @prop({ required: false, index: true, zh: '用户', ref: 'user' })
  user: string;
  @prop({ required: false, index: true, zh: '来源' })
  source: string;
  @prop({ required: false, index: true, zh: '来源类型' })
  source_type: string;
  @prop({
    required: false,
    index: true,
    zh: '类型',
    remark: '字典表:like_type',
  })
  type: string;
  @prop({ required: false, index: true, zh: '创建时间' })
  create_time: string;
  @prop({
    required: false,
    index: true,
    zh: '是否启用',
    remark: '字典表:is_use',
    default: '0',
  })
  is_use: string;
}
