import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'location' },
})
export class Location extends BaseModel {
  @prop({ required: false, index: true, zh: '区域' })
  region: string;
  @prop({
    required: false,
    index: true,
    zh: '类型',
    remark: '字典表:project_type',
  })
  type: string;
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({ required: false, index: false, zh: '图片' })
  file: Array<any>;
  @prop({ required: false, index: false, zh: '语音' })
  voice: Array<any>;
  @prop({ required: false, index: false, zh: '联系电话' })
  phone: string;
  @prop({ required: false, index: false, zh: '地点' })
  address: string;
  @prop({ required: false, index: false, zh: '金额' })
  money: number;
  @prop({ required: false, index: false, zh: '票务政策' })
  ticket: string;
  @prop({ required: false, index: false, zh: '开放时间' })
  open_time: string;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: false, zh: '创建时间' })
  create_time: string;
  @prop({ required: false, index: true, zh: '排序' })
  sort: number;
  @prop({
    required: false,
    index: true,
    zh: '是否启用',
    remark: '字典表:is_use',
    default: '0',
  })
  is_use: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表：exam_status',
    default: '0',
  })
  status: string;
}
