import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'map' },
})
export class Map extends BaseModel {
  @prop({ required: false, index: true, zh: '地点名称' })
  name: string;
  @prop({ required: false, index: false, zh: '经度' })
  longitude: number;
  @prop({ required: false, index: false, zh: '纬度' })
  latitude: number;
  @prop({ required: false, index: false, zh: '宽', default: 20 })
  width: number;
  @prop({ required: false, index: false, zh: '高', default: 30 })
  height: number;
  @prop({ required: false, index: false, zh: '音频' })
  audio: Array<any>;
  @prop({ required: false, index: false, zh: '自定义标记点上方的气泡窗口' })
  callout: object;
  @prop({
    required: false,
    index: false,
    zh: '是否启用',
    remark: '字典表:is_use',
    default: '0',
  })
  is_use: string;
}
