import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'media' },
})
export class Media extends BaseModel {
  @prop({ required: false, index: true, zh: '区域' })
  region: string;
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({
    required: false,
    index: true,
    zh: '类型',
    remark: '字典表:media_type',
  })
  type: string;
  @prop({ required: false, index: false, zh: '文件' })
  file: Array<any>;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: true, zh: '创建时间' })
  create_time: string;
  @prop({ required: false, index: true, zh: '排序' })
  sort: number;
  @prop({
    required: false,
    index: true,
    zh: '是否启用',
    remark: '字典表:is_use',
    default: '0',
  })
  is_use: string;
}
