import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'news' },
})
export class News extends BaseModel {
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({
    required: false,
    index: true,
    zh: '新闻类型',
    remark: '字典表:news_type',
  })
  type: string;
  @prop({ required: false, index: false, zh: '定时发布' })
  fixed_time: string;
  @prop({ required: false, index: false, zh: '来源' })
  source: string;
  @prop({ required: false, index: false, zh: '编辑' })
  author: string;
  @prop({ required: false, index: false, zh: '图片' })
  file: Array<any>;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: true, zh: '排序' })
  sort: number;
  @prop({
    required: false,
    index: true,
    zh: '是否启用',
    remark: '字典表:is_use',
    default: '0',
  })
  is_use: string;
}
