import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'order' },
})
export class Order extends BaseModel {
  @prop({ required: true, index: true, zh: '用户', ref: 'user' })
  user: string;
  @prop({ required: true, index: true, zh: '来源' })
  source: object;
  @prop({ required: false, index: false, zh: '来源名称' })
  source_name: string;
  @prop({
    required: false,
    index: true,
    zh: '类型',
    remark: '字典表:order_type',
  })
  type: string;
  @prop({ required: false, index: false, zh: '金额' })
  money: number;
  @prop({ required: false, index: false, zh: '优惠金额' })
  coupon_money: number;
  @prop({ required: false, index: false, zh: '总金额' })
  total_money: number;
  @prop({ required: false, index: false, zh: '日期' })
  date: string;
  @prop({ required: false, index: false, zh: '数量' })
  num: number;
  @prop({ required: false, index: false, zh: '游客信息' })
  identity: Array<any>;
  @prop({ required: false, index: false, zh: '优惠' })
  discount: string;
  @prop({ required: false, index: false, zh: '下单时间' })
  buy_time: string;
  @prop({ required: false, index: false, zh: '支付时间' })
  pay_time: string;
  @prop({ required: false, index: false, zh: '支付数据' })
  pay: Array<any>;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表:order_status',
  })
  status: string;
}
