import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'problem' },
})
export class Problem extends BaseModel {
  @prop({ required: false, index: true, zh: '问题' })
  question: string;
  @prop({ required: false, index: false, zh: '答案' })
  answer: string;
  @prop({ required: false, index: true, zh: '排序' })
  sort: number;
  @prop({
    required: false,
    index: true,
    zh: '是否启用',
    remark: '字典表:is_use',
    default: '0',
  })
  is_use: string;
}
