import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'rateOrder' },
})
export class RateOrder extends BaseModel {
  @prop({ required: false, index: true, zh: '订单', ref: 'order' })
  order: string;
  @prop({ required: false, index: true, zh: '来源' })
  source: string;
  @prop({ required: false, index: true, zh: '用户', ref: 'user' })
  user: string;
  @prop({
    required: false,
    index: true,
    zh: '类型',
    remark: '字典表:order_type',
  })
  type: string;
  @prop({ required: false, index: true, zh: '评分' })
  rate: number;
  @prop({ required: false, index: false, zh: '内容' })
  content: string;
  @prop({ required: false, index: false, zh: '图片' })
  file: Array<any>;
  @prop({ required: false, index: true, zh: '评价时间' })
  create_time: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表:exam_status',
    default: '0',
  })
  status: string;
}
