import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'region' },
})
export class Region extends BaseModel {
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({ required: false, index: false, zh: '地址' })
  address: string;
  @prop({ required: false, index: false, zh: '电话号' })
  phone: string;
  @prop({ required: false, index: false, zh: '排序' })
  sort: number;
  @prop({
    required: false,
    index: true,
    zh: '类型',
    remark: '字典表:region_type',
  })
  type: string;
  @prop({
    required: false,
    index: true,
    zh: '是否启用',
    remark: '字典表:is_use',
    default: '0',
  })
  is_use: string;
}
