import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'room' },
})
export class Room extends BaseModel {
  @prop({ required: false, index: true, zh: '酒店民宿' })
  hotel: string;
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({ required: false, index: true, zh: '价格' })
  money: string;
  @prop({ required: false, index: true, zh: '数量' })
  num: number;
  @prop({ required: false, index: false, zh: '图片' })
  file: Array<any>;
  @prop({ required: false, index: false, zh: '基本信息' })
  brief: string;
  @prop({ required: false, index: true, zh: '排序' })
  sort: number;
  @prop({
    required: false,
    index: false,
    zh: '是否使用',
    remark: '字典表:is_use',
  })
  is_use: string;
}
