import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'ticket' },
})
export class Ticket extends BaseModel {
  @prop({ required: false, index: false, zh: '名称' })
  name: string;
  @prop({ required: false, index: false, zh: '图片' })
  file: Array<any>;
  @prop({ required: false, index: false, zh: '原价' })
  original_price: number;
  @prop({ required: false, index: false, zh: '销售金额' })
  money: number;
  @prop({ required: false, index: false, zh: '适用人群' })
  suit_person: string;
  @prop({ required: false, index: true, zh: '销售数量', default: 0 })
  buy_num: number;
  @prop({
    required: false,
    index: true,
    zh: '出游人群',
    remark: '字典表:ticket_person',
  })
  person: string;
  @prop({
    required: false,
    index: true,
    zh: '服务特色',
    remark: '字典表:ticket_type',
  })
  type: string;
  @prop({ required: false, index: true, zh: '地址' })
  address: string;
  @prop({ required: false, index: false, zh: '购买说明' })
  buy_explain: string;
  @prop({ required: false, index: true, zh: '使用说明' })
  use_explain: string;
  @prop({ required: false, index: false, zh: '费用说明' })
  money_explain: string;
  @prop({ required: false, index: false, zh: '其他说明' })
  other_explain: string;
  @prop({ required: false, index: false, zh: '开放时间' })
  open_time: string;
  @prop({ required: false, index: false, zh: '日期' })
  date: Array<any>;
  @prop({ required: false, index: false, zh: '联系电话' })
  phone: string;
  @prop({ required: false, index: false, zh: '排序' })
  sort: string;
  @prop({
    required: false,
    index: false,
    zh: '是否启用',
    remark: '字典表:is_use',
    default: '0',
  })
  is_use: string;
  @prop({
    required: false,
    index: false,
    zh: '状态',
    remark: '字典表:exam_status',
    default: '0',
  })
  status: string;
}
