import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'user' },
})
export class User extends BaseModel {
  @prop({ required: true, index: true, zh: 'openid' })
  openid: string;
  @prop({ required: false, index: true, zh: '真实姓名' })
  name: string;
  @prop({ required: false, index: true, zh: '昵称' })
  nick_name: string;
  @prop({ required: false, index: false, zh: '个人头像' })
  logo: Array<any>;
  @prop({ required: false, index: false, zh: '性别', remark: '字典表:gender' })
  gender: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: false, zh: '生日' })
  birthday: string;
  @prop({ required: false, index: true, zh: '用户类型', default: '0' })
  type: string;
  @prop({ required: false, index: true, zh: '所在城市' })
  city: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表:exam_status',
    default: '1',
  })
  status: string;
}
