import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_afterSale {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '订单' })
  'order': string = undefined;
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '申请理由' })
  'reason': string = undefined;
  @ApiProperty({ description: '凭证图片' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '申请时间' })
  'apply_time': string = undefined;
}

export class QDTO_afterSale extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['order', 'user', 'type', 'apply_time'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '订单' })
  'order': string = undefined;
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '申请时间' })
  'apply_time': string = undefined;
}

export class QVO_afterSale extends FVO_afterSale {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_afterSale {
  @ApiProperty({ description: '订单' })
  @Rule(RuleType['string']().empty(''))
  'order': string = undefined;
  @ApiProperty({ description: '用户' })
  @Rule(RuleType['string']().empty(''))
  'user': string = undefined;
  @ApiProperty({ description: '类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '申请理由' })
  @Rule(RuleType['string']().empty(''))
  'reason': string = undefined;
  @ApiProperty({ description: '凭证图片' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '申请时间' })
  @Rule(RuleType['string']().empty(''))
  'apply_time': string = undefined;
}

export class CVO_afterSale extends FVO_afterSale {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_afterSale extends CDTO_afterSale {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_afterSale extends FVO_afterSale {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
