import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_config {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '景区名称' })
  'name': string = undefined;
  @ApiProperty({ description: '电话号' })
  'phone': string = undefined;
  @ApiProperty({ description: '地址' })
  'address': string = undefined;
  @ApiProperty({ description: '图片' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '首页图片' })
  'logo_url': Array<any> = undefined;
  @ApiProperty({ description: '视频' })
  'video': Array<any> = undefined;
  @ApiProperty({ description: '开放时间' })
  'open_time': string = undefined;
  @ApiProperty({ description: '简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '优待政策' })
  'policy': string = undefined;
  @ApiProperty({ description: '用户协议' })
  'agreement': string = undefined;
  @ApiProperty({ description: '隐私政策' })
  'secret': string = undefined;
  @ApiProperty({ description: '景区地理经度' })
  'longitude': number = undefined;
  @ApiProperty({ description: '景区地理纬度' })
  'latitude': number = undefined;
  @ApiProperty({ description: '景区地图缩放比例' })
  'scale': number = undefined;
  @ApiProperty({ description: '底部文案' })
  'bottom_title': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_config extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '景区名称' })
  'name': string = undefined;
}

export class QVO_config extends FVO_config {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_config {
  @ApiProperty({ description: '景区名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '电话号' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '地址' })
  @Rule(RuleType['string']().empty(''))
  'address': string = undefined;
  @ApiProperty({ description: '图片' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '首页图片' })
  @Rule(RuleType['array']().empty(''))
  'logo_url': Array<any> = undefined;
  @ApiProperty({ description: '视频' })
  @Rule(RuleType['array']().empty(''))
  'video': Array<any> = undefined;
  @ApiProperty({ description: '开放时间' })
  @Rule(RuleType['string']().empty(''))
  'open_time': string = undefined;
  @ApiProperty({ description: '简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '优待政策' })
  @Rule(RuleType['string']().empty(''))
  'policy': string = undefined;
  @ApiProperty({ description: '用户协议' })
  @Rule(RuleType['string']().empty(''))
  'agreement': string = undefined;
  @ApiProperty({ description: '隐私政策' })
  @Rule(RuleType['string']().empty(''))
  'secret': string = undefined;
  @ApiProperty({ description: '底部文案' })
  @Rule(RuleType['string']().empty(''))
  'bottom_title': string = undefined;
  @ApiProperty({ description: '景区地理经度' })
  @Rule(RuleType['number']().empty(''))
  'longitude': number = undefined;
  @ApiProperty({ description: '景区地理纬度' })
  @Rule(RuleType['number']().empty(''))
  'latitude': number = undefined;
  @ApiProperty({ description: '景区地图缩放比例' })
  @Rule(RuleType['number']().empty(''))
  'scale': number = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_config extends FVO_config {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_config extends CDTO_config {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_config extends FVO_config {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
