import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_coupon {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '数量' })
  'num': number = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '失效方式' })
  'expire_type': string = undefined;
  @ApiProperty({ description: '失效配置' })
  'expire_config': object = undefined;
  @ApiProperty({ description: '减免方式' })
  'discount_type': string = undefined;
  @ApiProperty({ description: '减免配置' })
  'discount_config': object = undefined;
  @ApiProperty({ description: '使用限制' })
  'use_limit': string = undefined;
  @ApiProperty({ description: '使用配置' })
  'use_limit_config': object = undefined;
  @ApiProperty({ description: '领取限制' })
  'get_limit': string = undefined;
  @ApiProperty({ description: '领取配置' })
  'get_limit_config': object = undefined;
  @ApiProperty({ description: '简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '排序' })
  'sort': number = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
}

export class QDTO_coupon extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'name',
      'type',
      'expire_type',
      'discount_type',
      'sort',
      'is_use',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '失效方式' })
  'expire_type': string = undefined;
  @ApiProperty({ description: '减免方式' })
  'discount_type': string = undefined;
  @ApiProperty({ description: '排序' })
  'sort': number = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
}

export class QVO_coupon extends FVO_coupon {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_coupon {
  @ApiProperty({ description: '名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '数量' })
  @Rule(RuleType['number']().empty(''))
  'num': number = undefined;
  @ApiProperty({ description: '类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '失效方式' })
  @Rule(RuleType['string']().empty(''))
  'expire_type': string = undefined;
  @ApiProperty({ description: '失效配置' })
  @Rule(RuleType['object']().empty(''))
  'expire_config': object = undefined;
  @ApiProperty({ description: '减免方式' })
  @Rule(RuleType['string']().empty(''))
  'discount_type': string = undefined;
  @ApiProperty({ description: '减免配置' })
  @Rule(RuleType['object']().empty(''))
  'discount_config': object = undefined;
  @ApiProperty({ description: '使用限制' })
  @Rule(RuleType['string']().empty(''))
  'use_limit': string = undefined;
  @ApiProperty({ description: '使用配置' })
  @Rule(RuleType['object']().empty(''))
  'use_limit_config': object = undefined;
  @ApiProperty({ description: '领取限制' })
  @Rule(RuleType['string']().empty(''))
  'get_limit': string = undefined;
  @ApiProperty({ description: '领取配置' })
  @Rule(RuleType['object']().empty(''))
  'get_limit_config': object = undefined;
  @ApiProperty({ description: '简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '排序' })
  @Rule(RuleType['number']().empty(''))
  'sort': number = undefined;
  @ApiProperty({ description: '是否启用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_coupon extends FVO_coupon {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_coupon extends CDTO_coupon {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_coupon extends FVO_coupon {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
