import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_map {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '地点名称' })
  'name': string = undefined;
  @ApiProperty({ description: '经度' })
  'longitude': number = undefined;
  @ApiProperty({ description: '纬度' })
  'latitude': number = undefined;
  @ApiProperty({ description: '宽' })
  'width': number = undefined;
  @ApiProperty({ description: '高' })
  'height': number = undefined;
  @ApiProperty({ description: '音频' })
  'audio': Array<any> = undefined;
  @ApiProperty({ description: '自定义标记点上方的气泡窗口' })
  'callout': object = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
}

export class QDTO_map extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
}

export class QVO_map extends FVO_map {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_map {
  @ApiProperty({ description: '地点名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '经度' })
  @Rule(RuleType['number']().empty(''))
  'longitude': number = undefined;
  @ApiProperty({ description: '纬度' })
  @Rule(RuleType['number']().empty(''))
  'latitude': number = undefined;
  @ApiProperty({ description: '宽' })
  @Rule(RuleType['number']().empty(''))
  'width': number = undefined;
  @ApiProperty({ description: '高' })
  @Rule(RuleType['number']().empty(''))
  'height': number = undefined;
  @ApiProperty({ description: '音频' })
  @Rule(RuleType['array']().empty(''))
  'audio': Array<any> = undefined;
  @ApiProperty({ description: '自定义标记点上方的气泡窗口' })
  @Rule(RuleType['object']().empty(''))
  'callout': object = undefined;
  @ApiProperty({ description: '是否启用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_map extends FVO_map {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_map extends CDTO_map {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_map extends FVO_map {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
