import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_media {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '区域' })
  'region': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '文件' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '创建时间' })
  'create_time': string = undefined;
  @ApiProperty({ description: '排序' })
  'sort': number = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
}

export class QDTO_media extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['region', 'name', 'type', 'create_time', 'sort', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '区域' })
  'region': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '创建时间' })
  'create_time': string = undefined;
  @ApiProperty({ description: '排序' })
  'sort': number = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
}

export class QVO_media extends FVO_media {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_media {
  @ApiProperty({ description: '区域' })
  @Rule(RuleType['string']().empty(''))
  'region': string = undefined;
  @ApiProperty({ description: '名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '文件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '创建时间' })
  @Rule(RuleType['string']().empty(''))
  'create_time': string = undefined;
  @ApiProperty({ description: '排序' })
  @Rule(RuleType['number']().empty(''))
  'sort': number = undefined;
  @ApiProperty({ description: '是否启用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_media extends FVO_media {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_media extends CDTO_media {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_media extends FVO_media {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
