import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_news {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '新闻类型' })
  'type': string = undefined;
  @ApiProperty({ description: '定时发布' })
  'fixed_time': string = undefined;
  @ApiProperty({ description: '来源' })
  'source': string = undefined;
  @ApiProperty({ description: '编辑' })
  'author': string = undefined;
  @ApiProperty({ description: '图片' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '排序' })
  'sort': number = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
}

export class QDTO_news extends SearchBase {
  constructor() {
    const like_prop = ['name'];
    const props = ['type', 'source', 'author', 'sort', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '新闻类型' })
  'type': string = undefined;
  @ApiProperty({ description: '来源' })
  'source': string = undefined;
  @ApiProperty({ description: '编辑' })
  'author': string = undefined;
  @ApiProperty({ description: '排序' })
  'sort': number = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
}

export class QVO_news extends FVO_news {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_news {
  @ApiProperty({ description: '名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '新闻类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '定时发布' })
  @Rule(RuleType['string']().empty(''))
  'fixed_time': string = undefined;
  @ApiProperty({ description: '来源' })
  @Rule(RuleType['string']().empty(''))
  'source': string = undefined;
  @ApiProperty({ description: '编辑' })
  @Rule(RuleType['string']().empty(''))
  'author': string = undefined;
  @ApiProperty({ description: '图片' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '排序' })
  @Rule(RuleType['number']().empty(''))
  'sort': number = undefined;
  @ApiProperty({ description: '是否启用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_news extends FVO_news {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_news extends CDTO_news {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_news extends FVO_news {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
