import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_order {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '来源' })
  'source': object = undefined;
  @ApiProperty({ description: '来源名称' })
  'source_name': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '金额' })
  'money': number = undefined;
  @ApiProperty({ description: '优惠金额' })
  'coupon_money': number = undefined;
  @ApiProperty({ description: '总金额' })
  'total_money': number = undefined;
  @ApiProperty({ description: '日期' })
  'date': string = undefined;
  @ApiProperty({ description: '数量' })
  'num': number = undefined;
  @ApiProperty({ description: '游客信息' })
  'identity': Array<any> = undefined;
  @ApiProperty({ description: '优惠' })
  'discount': string = undefined;
  @ApiProperty({ description: '下单时间' })
  'buy_time': string = undefined;
  @ApiProperty({ description: '支付时间' })
  'pay_time': string = undefined;
  @ApiProperty({ description: '支付数据' })
  'pay': Array<any> = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_order extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['user', 'source_name', 'type', 'status'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '来源名称' })
  'source_name': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_order extends FVO_order {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_order {
  @ApiProperty({ description: '用户' })
  @Rule(RuleType['string']().empty(''))
  'user': string = undefined;
  @ApiProperty({ description: '来源' })
  @Rule(RuleType['object']().empty(''))
  'source': object = undefined;
  @ApiProperty({ description: '来源名称' })
  @Rule(RuleType['string']().empty(''))
  'source_name': string = undefined;
  @ApiProperty({ description: '类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '金额' })
  @Rule(RuleType['number']().empty(''))
  'money': number = undefined;
  @ApiProperty({ description: '优惠金额' })
  @Rule(RuleType['number']().empty(''))
  'coupon_money': number = undefined;
  @ApiProperty({ description: '总金额' })
  @Rule(RuleType['number']().empty(''))
  'total_money': number = undefined;
  @ApiProperty({ description: '日期' })
  @Rule(RuleType['string']().empty(''))
  'date': string = undefined;
  @ApiProperty({ description: '数量' })
  @Rule(RuleType['number']().empty(''))
  'num': number = undefined;
  @ApiProperty({ description: '游客信息' })
  @Rule(RuleType['array']().empty(''))
  'identity': Array<any> = undefined;
  @ApiProperty({ description: '优惠' })
  @Rule(RuleType['string']().empty(''))
  'discount': string = undefined;
  @ApiProperty({ description: '下单时间' })
  @Rule(RuleType['string']().empty(''))
  'buy_time': string = undefined;
  @ApiProperty({ description: '支付时间' })
  @Rule(RuleType['string']().empty(''))
  'pay_time': string = undefined;
  @ApiProperty({ description: '支付数据' })
  @Rule(RuleType['array']().empty(''))
  'pay': Array<any> = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_order extends FVO_order {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_order extends CDTO_order {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_order extends FVO_order {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
