import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_problem {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '问题' })
  'question': string = undefined;
  @ApiProperty({ description: '答案' })
  'answer': string = undefined;
  @ApiProperty({ description: '排序' })
  'sort': number = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
}

export class QDTO_problem extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['question', 'sort', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '问题' })
  'question': string = undefined;
  @ApiProperty({ description: '排序' })
  'sort': number = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
}

export class QVO_problem extends FVO_problem {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_problem {
  @ApiProperty({ description: '问题' })
  @Rule(RuleType['string']().empty(''))
  'question': string = undefined;
  @ApiProperty({ description: '答案' })
  @Rule(RuleType['string']().empty(''))
  'answer': string = undefined;
  @ApiProperty({ description: '排序' })
  @Rule(RuleType['number']().empty(''))
  'sort': number = undefined;
  @ApiProperty({ description: '是否启用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_problem extends FVO_problem {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_problem extends CDTO_problem {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_problem extends FVO_problem {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
