import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_rateOrder {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '订单' })
  'order': string = undefined;
  @ApiProperty({ description: '来源' })
  'source': string = undefined;
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '评分' })
  'rate': number = undefined;
  @ApiProperty({ description: '内容' })
  'content': string = undefined;
  @ApiProperty({ description: '图片' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '评价时间' })
  'create_time': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_rateOrder extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'order',
      'source',
      'user',
      'type',
      'rate',
      'create_time',
      'status',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '订单' })
  'order': string = undefined;
  @ApiProperty({ description: '来源' })
  'source': string = undefined;
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '评分' })
  'rate': number = undefined;
  @ApiProperty({ description: '评价时间' })
  'create_time': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_rateOrder extends FVO_rateOrder {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_rateOrder {
  @ApiProperty({ description: '订单' })
  @Rule(RuleType['string']().empty(''))
  'order': string = undefined;
  @ApiProperty({ description: '来源' })
  @Rule(RuleType['string']().empty(''))
  'source': string = undefined;
  @ApiProperty({ description: '用户' })
  @Rule(RuleType['string']().empty(''))
  'user': string = undefined;
  @ApiProperty({ description: '类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '评分' })
  @Rule(RuleType['number']().empty(''))
  'rate': number = undefined;
  @ApiProperty({ description: '内容' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '图片' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '评价时间' })
  @Rule(RuleType['string']().empty(''))
  'create_time': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_rateOrder extends FVO_rateOrder {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_rateOrder extends CDTO_rateOrder {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_rateOrder extends FVO_rateOrder {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
