import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_ticket {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '图片' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '原价' })
  'original_price': number = undefined;
  @ApiProperty({ description: '销售金额' })
  'money': number = undefined;
  @ApiProperty({ description: '适用人群' })
  'suit_person': string = undefined;
  @ApiProperty({ description: '销售数量' })
  'buy_num': number = undefined;
  @ApiProperty({ description: '地址' })
  'address': string = undefined;
  @ApiProperty({ description: '出游人群' })
  'person': string = undefined;
  @ApiProperty({ description: '服务特色' })
  'type': string = undefined;
  @ApiProperty({ description: '购买说明' })
  'buy_explain': string = undefined;
  @ApiProperty({ description: '使用说明' })
  'use_explain': string = undefined;
  @ApiProperty({ description: '费用说明' })
  'money_explain': string = undefined;
  @ApiProperty({ description: '其他说明' })
  'other_explain': string = undefined;
  @ApiProperty({ description: '开放时间' })
  'open_time': string = undefined;
  @ApiProperty({ description: '日期' })
  'date': Array<any> = undefined;
  @ApiProperty({ description: '联系电话' })
  'phone': string = undefined;
  @ApiProperty({ description: '排序' })
  'sort': string = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_ticket extends SearchBase {
  constructor() {
    const like_prop = ['name'];
    const props = [
      'buy_num',
      'sort',
      'date',
      'is_use',
      'address',
      'status',
      'person',
      'type',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '销售数量' })
  'buy_num': number = undefined;
  @ApiProperty({ description: '排序' })
  'sort': string = undefined;
  @ApiProperty({ description: '地址' })
  'address': string = undefined;
  @ApiProperty({ description: '出游人群' })
  'person': string = undefined;
  @ApiProperty({ description: '日期' })
  'date': string = undefined;
  @ApiProperty({ description: '服务特色' })
  'type': string = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_ticket extends FVO_ticket {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_ticket {
  @ApiProperty({ description: '名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '图片' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '原价' })
  @Rule(RuleType['number']().empty(''))
  'original_price': number = undefined;
  @ApiProperty({ description: '销售金额' })
  @Rule(RuleType['number']().empty(''))
  'money': number = undefined;
  @ApiProperty({ description: '适用人群' })
  @Rule(RuleType['string']().empty(''))
  'suit_person': string = undefined;
  @ApiProperty({ description: '销售数量' })
  @Rule(RuleType['number']().empty(''))
  'buy_num': number = undefined;
  @ApiProperty({ description: '出游人群' })
  @Rule(RuleType['string']().empty(''))
  'person': string = undefined;
  @ApiProperty({ description: '特色服务' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '地址' })
  @Rule(RuleType['string']().empty(''))
  'address': string = undefined;
  @ApiProperty({ description: '购买说明' })
  @Rule(RuleType['string']().empty(''))
  'buy_explain': string = undefined;
  @ApiProperty({ description: '使用说明' })
  @Rule(RuleType['string']().empty(''))
  'use_explain': string = undefined;
  @ApiProperty({ description: '费用说明' })
  @Rule(RuleType['string']().empty(''))
  'money_explain': string = undefined;
  @ApiProperty({ description: '其他说明' })
  @Rule(RuleType['string']().empty(''))
  'other_explain': string = undefined;
  @ApiProperty({ description: '开放时间' })
  @Rule(RuleType['string']().empty(''))
  'open_time': string = undefined;
  @ApiProperty({ description: '日期' })
  @Rule(RuleType['array']().empty(''))
  'date': Array<any> = undefined;
  @ApiProperty({ description: '联系电话' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '排序' })
  @Rule(RuleType['string']().empty(''))
  'sort': string = undefined;
  @ApiProperty({ description: '是否启用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_ticket extends FVO_ticket {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_ticket extends CDTO_ticket {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_ticket extends FVO_ticket {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
