import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_userCoupon {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '过期时间' })
  'time': string = undefined;
  @ApiProperty({ description: '优惠卷' })
  'coupon': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QDTO_userCoupon extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['user', 'type', 'coupon', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '优惠卷' })
  'coupon': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QVO_userCoupon extends FVO_userCoupon {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_userCoupon {
  @ApiProperty({ description: '用户' })
  @Rule(RuleType['string']().empty(''))
  'user': string = undefined;
  @ApiProperty({ description: '类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '过期时间' })
  @Rule(RuleType['string']().empty(''))
  'time': string = undefined;
  @ApiProperty({ description: '优惠卷' })
  @Rule(RuleType['string']().empty(''))
  'coupon': string = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_userCoupon extends FVO_userCoupon {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_userCoupon extends CDTO_userCoupon {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_userCoupon extends FVO_userCoupon {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
