import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService } from 'free-midway-component';
import { Article } from '../entity/article.entity';
import { Like } from '../entity/like.entity';
import { Types } from 'mongoose';
const ObjectId = Types.ObjectId;
type modelType = ReturnModelType<typeof Article>;
@Provide()
export class ArticleService extends BaseService<modelType> {
  @InjectEntityModel(Article)
  model: modelType;

  @InjectEntityModel(Like)
  lModel: ReturnModelType<typeof Like>;

  // 查看收藏或点赞
  async article(filter) {
    const { skip = 0, limit, user, ...info } = filter;
    const list: any = await this.model
      .find(info)
      .skip(skip)
      .limit(limit)
      .lean();
    const total = await this.model.count(info);
    for (const val of list) {
      const result1: any = await this.lModel
        .findOne({
          source: new ObjectId(val._id).toString(),
          user: user,
          type: '0',
        })
        .lean();
      const result2: any = await this.lModel
        .findOne({
          source: new ObjectId(val._id).toString(),
          user: user,
          type: '1',
        })
        .lean();
      if (result1) {
        val.is_like = true;
        val.like = new ObjectId(result1._id).toString();
      } else val.is_like = false;
      val.like_num = await this.lModel.count({
        type: '0',
        source: new ObjectId(val._id).toString(),
      });
      if (result2) {
        val.is_collect = true;
        val.collect = new ObjectId(result2._id).toString();
      } else val.is_collect = false;
      val.collect_num = await this.lModel.count({
        type: '1',
        source: new ObjectId(val._id).toString(),
      });
    }
    return { list, total };
  }

  // 修改状态 删除收藏跟点赞
  async BeforeUpdate(id) {
    await this.lModel.deleteMany({ source: id });
  }
}
