import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService } from 'free-midway-component';
import { Like } from '../entity/like.entity';
import { Article } from '../entity/article.entity';
import { Hotel } from '../entity/hotel.entity';
import { Location } from '../entity/location.entity';
import { Ticket } from '../entity/ticket.entity';
import { Types } from 'mongoose';
const ObjectId = Types.ObjectId;
type modelType = ReturnModelType<typeof Like>;
@Provide()
export class LikeService extends BaseService<modelType> {
  @InjectEntityModel(Like)
  model: modelType;

  @InjectEntityModel(Article)
  aModel: ReturnModelType<typeof Article>;

  @InjectEntityModel(Hotel)
  hModel: ReturnModelType<typeof Hotel>;

  @InjectEntityModel(Location)
  lModel: ReturnModelType<typeof Location>;

  @InjectEntityModel(Ticket)
  tModel: ReturnModelType<typeof Ticket>;

  // 查看收藏或点赞
  async article(filter) {
    const { skip = 0, limit, ...info } = filter;
    const list = await this.model.find(info).skip(skip).limit(limit).lean();
    const total = await this.model.count(info);
    const data = [];
    for (const val of list) {
      let result: any;
      if (val.source_type === 'article')
        result = await this.aModel.findById(val.source).lean();
      else if (val.source_type === 'hotel')
        result = await this.hModel.findById(val.source).lean();
      else if (val.source_type === 'location')
        result = await this.lModel.findById(val.source).lean();
      else if (val.source_type === 'ticket')
        result = await this.tModel.findById(val.source).lean();
      if (info.type === '0') {
        result.is_like = true;
        result.like = new ObjectId(val._id).toString();
        result.like_num = await this.model.count({
          type: '0',
          source: val.source,
        });
      } else {
        result.is_collect = true;
        result.collect = new ObjectId(val._id).toString();
        result.collect_num = await this.model.count({
          type: '1',
          source: val.source,
        });
      }
      data.push(result);
    }
    return { data, total };
  }
}
